Whamcloud - gitweb
02f0a30be8324f29779a363da83dbebeebcff25a
[fs/lustre-release.git] / contrib / lbuild / lbuild
1 #!/bin/bash
2
3 # vim:expandtab:shiftwidth=4:softtabstop=4:tabstop=4:
4
5 # this is an alternative FD for stdout, to be used especially when we are
6 # taking stdout from a function as it's return value.  i.e. foo=$(bar)
7 # this is a workaround until a version of bash where we can put xtrace
8 # on a specific FD
9 exec 3>&1; STDOUT=3
10
11 #set -x
12 xtrace="+x"
13 if [[ $SHELLOPTS = *xtrace* ]]; then
14     xtrace="-x"
15 fi
16 shopt -s extdebug
17
18 # Assume that lbuild's support files can be found in the same
19 # canonicalized path as this very script.
20 LBUILD_SCRIPT=$(readlink -f ${0})
21 LBUILD_DIR=${LBUILD_DIR:-$(dirname ${LBUILD_SCRIPT})}
22
23 # include the exit_traps library
24 . ${LBUILD_DIR}/exit_traps.sh
25 . ${LBUILD_DIR}/funcs.sh
26
27 # our children should die when we do
28 push_exit_trap "kill -INT -$$ || true" kill_children
29
30 # increment this if you have made a change that should force a new kernel
31 # to build built
32 BUILD_GEN=8
33
34 TOPDIR="$PWD"
35
36 KERNELDIR=
37 LINUX=
38 LUSTRE=
39 RELEASE=false
40 # XXX - some recent hacking has pretty much neutered this option.
41 #       search through this file for "-bb" and see how many places
42 #       simply don't account for this option
43 DO_SRC=true
44 DOWNLOAD=true
45 CANONICAL_TARGET=
46 TARGET=
47 TARGET_ARCH="$(uname -m)"
48 CONFIGURE_FLAGS=
49 EXTERNAL_PATCHES=
50 EXTRA_VERSION=
51 STAGEDIR=
52 TMPDIR=${TMPDIR:-"/var/tmp"}
53 TIMESTAMP=
54 # default OFED
55 OFED_TYPE="inkernel"
56 # this is the dir that should be used to store reuse products
57 REUSEBUILD=
58 # should cached products be used or force rebuilding?
59 USE_BUILD_CACHE=true
60 # what does this do exactly?  does it imply no kernel build?
61 IOKITRPM=true
62 OSDLDISKFSRPM=true
63 OSDZFSRPM=false
64 SMPTYPES="smp bigsmp default ''"
65 PATCHLESS=false
66 PATCHLESS_SERVER=false
67 WITH_ZFS=""
68 XEN=false
69 LINUXOBJ=
70 DISTRO=
71 KERNELTREE=
72 # default to not adding -lustre- into the kernel RPM package names
73 KERNEL_LUSTRE_NAMING=false
74 # default not use kabi check.
75 USE_KABI=false
76
77 # patchless build
78 KERNELRPMSBASE=
79 RPMSMPTYPE=
80
81 # from target file
82 SERIES=
83 BASE_ARCHS=
84 BIGMEM_ARCHS=
85 BOOT_ARCHS=
86 JENSEN_ARCHS=
87 SMP_ARCHS=
88 BIGSMP_ARCHS=
89 PSERIES64_ARCHS=
90 UP_ARCHS=
91
92 # not in the target file any more
93 CONFIG=
94
95 # build the lustre-tests rpm?
96 LUSTRE_TESTS=true
97
98 DATE=$(date)
99
100 RPMBUILD=
101
102 export CC=${CC:-gcc}
103
104 # Readlink is not present on some older distributions: emulate it.
105 readlink() {
106     local path=$1 ll
107
108     if [ -L "$path" ]; then
109         ll="$(LC_ALL=C ls -l "$path" 2> /dev/null)" &&
110         echo "${ll/* -> }"
111     else
112         return 1
113     fi
114 }
115
116 usage() {
117     cat <<EOF
118 Usage: ${0##*/} [OPTION]... [-- <lustre configure options>]
119
120   --external-patches=EXTERNAL_PATCHES
121     Directory similar to lustre/lustre/kernel_patches/ that lbuild should
122     look for seres and config files in before looking in the lustre
123     tree.
124
125   --extraversion=EXTRAVERSION
126     Text to use for the rpm release and kernel extraversion.
127
128   --timestamp=TIMESTAMP
129     Date of building lustre in format YYYYMMDDhhmmss
130
131   --reusebuild=DIR
132     Try to reuse old kernel builds from DIR
133
134   --kernelrpm=DIR
135     Path to distro kernel RPM collection
136
137   --ccache
138     Use ccache
139
140   --norpm
141     Unused.
142
143   --patchless
144     Build lustre client only
145
146   --patchless-server
147     Build lustre server without patching the kernel
148
149   --distro=DISTRO
150     Which distro using. Autodetect by default
151
152   --kerneldir=KERNELDIR
153     Directory containing Linux source tarballs referenced by target
154     files.
155
156   --kerneltree=KERNELTREE
157     Directory containing dirs with Linux source tarballs referenced by target
158     files. Dir names in format kernel version ('2.6.9', etc.)
159
160   --linux=LINUX --with-linux=LINUX
161     Directory of Linux kernel sources.  When this option is used, only
162     Lustre modules and userspace are built.
163
164   --lustre=LUSTRE
165     Path to an existing lustre source tarball to use.
166
167   --nodownload
168     Do not try to download a kernel from downloads.hpdd.intel.com
169
170   --nosrc
171     Do not build a .src.rpm, a full kernel patch, or a patched kernel
172     tarball.
173
174   --ofed-type
175     Type of OFED to build with lustre: inkernel, ofa, mlnx, ifs
176     ofa: OpenFabrics Alliance
177     mlnx: Mellanox
178     ifs: Intel True Scale Fabric
179
180   --ofed-version
181     Version of external OFED to build with lustre
182
183   --mlnx-version
184     Version of external Mellanox OFED to build with lustre
185
186   --ofed-src
187     Tarball for either OFED. Tarball must follow below format
188     OFED-<ofed-version>.tgz regardless of vendors
189     It's likely that you need to reconstruct the directory name
190     It must be placed under KERNELTREE directory
191
192   --ldiskfs
193     Build with ldiskfs support. (Deprecated, always true)
194
195   --noiokit
196     Do not build lustre-iokit RPM. Now true by default
197
198   --publish
199     Unused.
200
201   --release
202     Specifies that the files generated do not include timestamps, and
203     that this is an official release.
204
205   --disable-zfs
206     Build Lustre without ZFS.
207
208   --src
209     Build a .src.rpm, a full kernel patch, and a patched kernel tarball.
210
211   --stage=DIR
212     Directory used to stage packages for release.  RPMs will be placed
213     more or less in DIR/<target>-<arch>, and the tarball will be
214     placed in DIR.
215
216   --target=TARGET
217     The name of the target to build.  The available targets are listed
218     below.
219
220   --xen
221     Builds a Xen domX kernel.
222
223   --set-value
224     Sets a variable to a given value.
225
226 EOF
227
228 #   list_targets
229
230     fatal "$1" "$2"
231 }
232
233 # canonicalize a relative path to a file
234 canon_filepath() {
235     local PATH="$1"
236
237     if [ ! -f "$PATH" ]; then
238         return 1
239     fi
240
241     local FILE=${PATH##*/}
242     local DIR=${PATH%/*}
243
244     echo $(canon_path "$DIR")/$FILE
245     return 0
246 }
247
248 # canonicalize a relative path to a dir
249 canon_path() {
250     local PATH="$1"
251
252     if [ ! -d "$PATH" ]; then
253         return 1
254     fi
255
256     pushd "$PATH" >/dev/null || return 1
257     local CANONPATH=$PWD
258     popd >/dev/null
259
260     echo "$CANONPATH"
261     return 0
262 }
263
264 check_options() {
265
266     if [ -z "$LUSTRE" -o ! -r "$LUSTRE" ]; then
267         usage 1 "Could not find Lustre source tarball '$LUSTRE'."
268     fi
269
270         if $PATCHLESS && $PATCHLESS_SERVER; then
271                 usage 1 "Can not use both --patchless and --patchless-server."
272         fi
273
274         if [ -n "${OFED_SRC}" ]; then
275                 if [ -z "${OFED_VERSION}" ]; then
276                         usage 1 "Need to provide version for file ${OFED_SRC}."
277                 fi
278                 if [ "${OFED_TYPE}" = "inkernel" ]; then
279                         usage 1 "Need to provide ofed type for file ${OFED_SRC}."
280                 fi
281         else
282                 if [ "${OFED_TYPE}" != "inkernel" -a -z "${OFED_VERSION}" ]; then
283                         usage 1 "Need to provide version for $OFED_TYPE OFED"
284                 fi
285
286                 if [ "${OFED_TYPE}" = "inkernel" -a -n "${OFED_VERSION}" ]; then
287                         usage 1 "Can not specify version with inkernel OFED"
288                 fi
289         fi
290
291     if [ -z "$DISTRO" ] ; then
292         DISTRO=$(autodetect_distro)
293         # remove separator
294         DISTRO=${DISTRO/-/}
295     fi
296     DISTROMAJ=${DISTRO%%.*}
297
298     [ -z "$TARGET" ] && TARGET=$(autodetect_target "$DISTRO")
299
300     if [ -z "$LINUX" ]; then
301         [ "$KERNELDIR" -o "$KERNELTREE" ] || \
302             usage 1 "A kernel directory must be specified with --kerneldir or --kerneltree."
303
304         [ -d "$KERNELDIR" -o -d "$KERNELTREE" ] || \
305             usage 1 "$KERNELDIR and $KERNELTREE are not a directory."
306
307 #       TARGET_FILE="$TOPDIR/lustre/kernel_patches/targets/$TARGET.target"
308 #       [ -r "$TARGET_FILE" ] || \
309 #               usage 1 "Target '$TARGET' was not found."
310     fi
311
312     case $TARGET in
313         3.12-sles12 | 4.4-sles12)
314             CANONICAL_TARGET="sles12"
315             ;;
316         3.10-rhel7*)
317             CANONICAL_TARGET="rhel7"
318             ;;
319         2.6-rhel6*)
320             CANONICAL_TARGET="rhel6"
321             ;;
322         2.6-rhel5)
323             CANONICAL_TARGET="rhel5"
324             ;;
325         2.6-rhel4)
326             CANONICAL_TARGET="rhel-2.6"
327             ;;
328         2.6-suse)
329             CANONICAL_TARGET="sles-2.6"
330             ;;
331         2.6-sles10)
332             CANONICAL_TARGET="sles10-2.6"
333             ;;
334         2.6-sles11 | 3.0-sles11)
335             CANONICAL_TARGET="sles11"
336             ;;
337         2.6-oel5)
338             CANONICAL_TARGET="oel5"
339             ;;
340         hp_pnnl-2.4)
341             CANONICAL_TARGET="hp-pnnl-2.4"
342             ;;
343         2.6-vanilla \
344             | suse-2.4.21-2 \
345             | rh-2.4 \
346             | rhel-2.4 \
347             | sles-2.4 \
348             | 2.6-patchless)
349                 CANONICAL_TARGET="$TARGET"
350                 ;;
351     esac
352
353     local timestampnodig=$(echo $TIMESTAMP | sed -e s/[0-9]*//g)
354     [ "$timestampnodig" = "" ] || TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
355     local timestamplength="${#TIMESTAMP}"
356     if [ $timestamplength -eq 12 ]; then
357         TIMESTAMP="${TIMESTAMP}00"
358     elif [ $timestamplength -ne 14 ]; then
359         TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
360     fi
361
362     RPMBUILD=$(which rpmbuild 2>/dev/null | head -n 1)
363     RPMBUILD=${RPMBUILD:-$(which rpm 2>/dev/null | head -n 1)}
364     if [ -z "$RPMBUILD" ]; then
365         usage 1 "Could not find binary for making rpms (tried rpmbuild and rpm)."
366     fi
367
368     local BINDIR="$TOPDIR/bin"
369     if [ -d $BINDIR ]; then
370         rm -rf $BINDIR >/dev/null 2>&1 || true
371     fi
372
373     mkdir -p $BINDIR || fatal 1 "error trying to create $BINDIR"
374     export PATH=$BINDIR:$PATH
375
376     cat >${BINDIR}/rpmbuild <<EOF
377 #!/bin/bash
378
379 ARGS="\${FIND_REQUIRES:+--define \"__find_requires \$FIND_REQUIRES\"}"
380 for arg; do
381     case \$arg in
382     *\'* ) ARGS="\$ARGS \"\$arg\"" ;;
383     * ) ARGS="\$ARGS '\$arg'" ;;
384     esac
385 done
386
387 eval $RPMBUILD \$ARGS
388 EOF
389     chmod 755 ${BINDIR}/rpmbuild
390
391     if [ -n "$CCACHE" ]; then
392         which "$DISTCC" &>/dev/null && export DISTCC RPM_BUILD_NCPUS
393
394         if which "$CCACHE" &>/dev/null; then
395             local ccache=$(which "$CCACHE" 2>/dev/null | head -n 1)
396
397             ln -s "$ccache" ${BINDIR}/ccache
398             ln -s "$ccache" ${BINDIR}/cc
399             ln -s "$ccache" ${BINDIR}/$CC
400
401             export CCACHE
402             export CC="ccache $CC"
403             # zero the cache so we can see how effective we are being with it
404             echo -n "ccache "
405             ccache -z
406
407             # get some ccache stats when we are done
408             push_exit_trap '[ -n "$CCACHE" ] && ccache -s' "ccache_summary"
409             # should remove the ccache trap if lbuild is interrupted
410             trap 'echo "Received an INT TERM or HUP signal, terminating."; delete_exit_trap "ccache_summary"; exit 1' INT TERM HUP
411         fi
412     fi
413
414     return 0
415 }
416
417 # compare two versions $1 and $2. if $1 < $2, return 0 otherwise return 1.
418 compare_version () {
419     [[ $1 == $2 ]] && return 1
420     local IFS=.
421     local i val1=($1) val2=($2)
422
423     # padding zero to val1 if it needs
424     for ((i=${#val1[@]}; i<${#val2[@]}; i++)); do
425         val1[i]=0
426     done
427     for ((i=0; i<${#val1[@]}; i++)); do
428         [[ -z ${val2[i]} ]] && return 1
429
430         if [[ ${val1[i]} < ${val2[i]} ]]; then
431             return 0
432         elif [[ ${val1[i]} > ${val2[i]} ]]; then
433             return 1
434         fi
435     done
436     return 1
437 }
438
439 uniqify() {
440
441     echo $(echo "$*" | xargs -n 1 | sort -u)
442
443 }
444
445 fetch_url() {
446     local url="$1"
447     local target="$2"
448
449     if [ -z "$target" ]; then
450         fatal 1 "fetch_url() called without a target to fetch to"
451     fi
452
453     if [ -d $target ]; then
454         target+="/${url##*/}"
455     fi
456
457     local rc=0
458     if which wget >/dev/null 2>&1; then
459         if ! wget -nv "$url" -O "$target"; then
460             rc=${PIPESTATUS[0]}
461         fi
462     elif which curl >/dev/null 2>&1; then
463         if ! curl -n -L -s -o "$target" "$url"; then
464             rc=${PIPESTATUS[0]}
465         fi
466     else
467         fatal 1 "Could not find either wget or curl to fetch URLs."
468     fi
469
470     return $rc
471
472 }
473
474 download_srpm() {
475         local target=$1
476         local srpm=$2
477         local force="${3:-false}"
478
479         # let the download_file handle the concurrency
480         if $DOWNLOAD; then
481                 local location= \
482                 "https://downloads.hpdd.intel.com/public/kernels/$target/old"
483                 # get the location from a distro specific method if it exists
484                 if type -p kernel_srpm_location; then
485                         location=$(kernel_srpm_location)
486                 fi
487                 echo "Downloading $location/$srpm..."
488                 if ! download_file \
489                         "$location/$srpm" "$KERNELDIR/$srpm" "$force" 2>&1 ||
490                         [ ! -s "$KERNELDIR/$srpm" ]; then
491                         rm -f $KERNELDIR/$srpm
492                         fatal 1 "Could not download target $target's kernel \
493 SRPM $srpm from $location."
494                 fi
495         fi
496 }
497
498 download_debuginfo_common() {
499         local rpm=$1
500         local force="${2:-false}"
501
502         # let the download_file handle the concurrency
503         if $DOWNLOAD; then
504                 # get the location from a distro specific method if it exists
505                 if type -p kernel_debuginfo_location; then
506                 location=$(kernel_debuginfo_location)
507                 fi
508                 echo "Downloading $location/$rpm"
509                 if ! download_file \
510                         "$location/$rpm" "$KERNELRPMSBASE/$lnxmaj/$DISTROMAJ/$TARGET_ARCH/$rpm" "$force" 2>&1 ||
511                         [ ! -s "$KERNELRPMSBASE/$lnxmaj/$DISTROMAJ/$TARGET_ARCH/$rpm" ]; then
512                         rm -f $KERNELRPMSBASE/$lnxmaj/$DISTROMAJ/$TARGET_ARCH/$rpm
513                         fatal 1 "Could not download $rpm from $location."
514                 fi
515         fi
516 }
517
518 download_file() {
519     local from="$1"
520     local to="$2"
521     local force="$3"
522
523     local file=${from##*/}
524
525     if [ -d $to ]; then
526         to="$to/$file"
527     fi
528
529     local semaphore="$to-downloading"
530
531     is_downloading() {
532         if [ ! -f $semaphore ]; then
533             return 1
534         fi
535
536         # make sure the download has not been aborted
537         local now=$(date +%s)
538         local file_mtime=$(stat -c %Y "$to")
539         local staleness=$((now - file_mtime))
540         # let's assume an active download will write at least once a minute
541         if [ $staleness -gt 60 ]; then
542             return 1
543         fi
544
545         return 0
546     }
547
548     is_downloaded() {
549         # if the semaphore file exists, the file is either still downloading
550         # or a download was aborted and we cannot trust the target file
551         if [ -f $semaphore ]; then
552             return 1
553         fi
554
555         if ! is_downloading && [ -r "$to" ] && [ -s "$to" ]; then
556             return 0
557         fi
558
559         return 1
560     }
561
562     if $force || ! is_downloaded; then
563         if is_downloading; then
564             echo "Somebody else is downloading $from..."
565             while is_downloading; do
566                 echo "Waiting for $to to finish downloading"
567                 sleep 60
568             done
569             if is_downloaded; then
570                 return 0
571             else
572                 echo "The download we were waiting for seems to have been aborted"
573             fi
574
575         fi
576
577         if $DOWNLOAD; then
578             echo "Downloading $from..."
579             # flag others so they don't try to download also
580             push_exit_trap "rm -f $to $semaphore" "download"
581             touch $semaphore
582             if ! fetch_url "$from" "$to" || [ ! -s "$to" ]; then
583                 # the trap will remove the files via the fatal below
584                 fatal 1 "Could not download ${to##*/} from ${from%/*}/."
585             fi
586             rm -f $semaphore
587             delete_exit_trap "download"
588         else
589             fatal 1 "${to##*/} not found in directory ${to%/*}."
590         fi
591     fi
592
593     return 0
594
595 }
596
597 download_ofed() {
598         local ofed_type="$1"
599         local ofed_version="$2"
600         local force="${3:-false}"
601         local distro_name="${DISTRO}"
602         local arch="${TARGET_ARCH}"
603         local location
604         local file
605
606         #if a src tarball has been given in the command line, we use it
607         #The format of the tarball must be OFED-${OFED_VERSION}.tgz
608         [ -n "${OFED_SRC}" ] && return 0
609
610         case $ofed_type in
611                 ofa)
612                         location="https://www.openfabrics.org/downloads/OFED/ofed-${ofed_version}/"
613                         # version include RC
614                         if [[ $ofed_version = *-[rR][cC][0-9] ]]; then
615                                 ofed_version_loc=${ofed_version%%-[rR][cC][0-9]}
616                                 location="https://www.openfabrics.org/downloads/OFED/ofed-${ofed_version_loc}/"
617                         fi
618                         # daily build
619                         if [[ $ofed_version = *-daily ]]; then
620                                 ofed_version=${ofed_version/-daily/}
621                                 location="https://www.openfabrics.org/downloads/OFED/ofed-${ofed_version}-daily/"
622                                 # find the filename for latest version
623                                 ofed_version=$(curl -1 -s "$location" | sed -nre "s/.*href=\"OFED-(${ofed_version//./\\.}-[0-9]{8}-[0-9]{4}).tgz.*$/\1/p" | tail -1)
624                                 if [ -z "$ofed_version" ]; then
625                                         fatal 1 "Could not determine the filename of the OFED snapshot from daily "
626                                 fi
627                         fi
628
629                         file="OFED-${ofed_version}.tgz"
630                         download_file "$location/$file" "$KERNELTREE" "$force"
631                         ;;
632                 mlnx)
633                         location="http://www.mellanox.com/downloads/ofed/MLNX_OFED-${ofed_version}"
634                         # this is a work around for suse distro (sles11.3). what we need is
635                         # sles11sp3. We really need to redesign how we use target and distro
636                         [[ $distro_name =~ sles ]] && distro_name=${DISTRO/./sp}
637                         file="MLNX_OFED_LINUX-${ofed_version}-${distro_name}-${arch}.tgz"
638                         download_file "$location/$file" "$KERNELTREE" "$force"
639                         ;;
640                 ifs)
641                         location="http://downloadmirror.intel.com/24625/eng/"
642                         file="IntelIB-Basic.$(echo ${distro_name%%.*} | tr '[:lower:]' '[:upper:]')-${arch}.${ofed_version}.tgz"
643                         download_file "$location/$file" "$KERNELTREE" "$force"
644                         ;;
645                 *)
646                         fatal 1 "Error: unknown OFED type: $ofed_type"
647
648         esac
649         # version might change due to detect daily version
650         OFED_VERSION=${ofed_version}
651
652 }
653
654 load_target() {
655
656     EXTRA_VERSION_save="$EXTRA_VERSION"
657     for patchesdir in "$EXTERNAL_PATCHES" \
658                       "$TOPDIR/lustre/lustre/kernel_patches"; do
659         TARGET_FILE="$patchesdir/targets/$TARGET.target"
660         [ -r "$TARGET_FILE" ] && break
661     done
662     [ -r "$TARGET_FILE" ] || fatal 1 "Target $TARGET was not found."
663
664     echo "Loading target config file $TARGET.target..."
665
666     # if the caller specified an OFED_VERSION it should override whatever
667     # the target file specifies
668     local env_OFED_VERSION="$OFED_VERSION"
669
670     . "$TARGET_FILE"
671
672     if [ -n "$env_OFED_VERSION" ]; then
673         OFED_VERSION="$env_OFED_VERSION"
674     fi
675
676     # doesn't make any sense to build OFED for xen domX's
677     if $XEN; then
678         OFED_VERSION=""
679     fi
680
681     # XXX - set_rpm_smp_type is an ugly undeterministic hack.  it needs to
682     #       go away and the target just specify the $RPMSMPTYPE
683     [ -z "$RPMSMPTYPE" ] && set_rpm_smp_type
684
685     # CC might have been overwritten in TARGET_FILE
686     if [[ $CC != ccache\ * ]] && which "$CCACHE" &>/dev/null; then
687         export CCACHE && export CC="ccache $CC"
688     fi
689
690     if [ ! "$KERNELTREE" = "" ] && [ -d "$KERNELTREE" ]; then
691         KERNELDIR="$KERNELTREE/${lnxmaj}"
692         [ -d "$KERNELDIR" ] || mkdir "$KERNELDIR"
693     fi
694
695     # verify the series is available
696     if [ "$SERIES" ]; then
697         for series in $SERIES; do
698             for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
699                 [ -r "$patchesdir/series/$series" ] && continue 2
700             done
701             fatal 1 "Target $TARGET's series $SERIES could not be found.\nSearched:\n\t$EXTERNAL_PATCHES/series\n\t$TOPDIR/lustre/lustre/kernel_patches/series."
702         done
703     fi
704
705     # set the location of the .config file
706     local XENPOSTFIX=""
707     if $XEN; then
708         XENPOSTFIX="-xen"
709     fi
710
711     if [ -f $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET-$TARGET_ARCH.config ]; then
712         CONFIG_FILE="$TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET$XENPOSTFIX-$TARGET_ARCH.config"
713     fi
714
715     local lnxrelnew=${lnxrel//-/_}
716
717     # remember the EXTRA_VERSION before we diddle it here
718     # XXX - we really should not diddle with any values read in from the
719     #       target file.  if we want to modify a value, we should create
720     #       a new variable.
721     PRISTINE_EXTRA_VERSION=$EXTRA_VERSION
722
723     if ! $PATCHLESS && [ ! -f "$CONFIG_FILE" ]; then
724         fatal 1 "Config file for target $TARGET missing from $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/."
725     fi
726
727     if [ "$EXTRA_VERSION_save" ]; then
728         EXTRA_VERSION="$EXTRA_VERSION_save"
729     elif ! $RELEASE; then
730         # if there is no patch series, then this is not a lustre specific
731         # kernel.  don't make it look like one
732         if $PATCHLESS || [ -n "$SERIES" ]; then
733             EXTRA_VERSION=$(echo $EXTRA_VERSION | sed -e "s/\(.*_lustre\)\..*/\1/")
734         fi
735     fi
736     # EXTRA_VERSION=${EXTRA_VERSION//-/_}
737 }
738
739 tarflags() {
740     local file="$1"
741
742     echo -n '--wildcards '
743     case "$file" in
744         '')
745             fatal 1 "tarflags(): File name argument missing."
746             ;;
747         *.tar.gz | *.tgz)
748             echo '-zxf'
749             ;;
750         *.tar.bz2)
751             echo '-jxf'
752             ;;
753         *.tar)
754             echo '-xf'
755             ;;
756         *)
757             fatal 1 "tarflags(): Unrecognized tar extension in file: $1"
758             ;;
759     esac
760
761 }
762
763 untar() {
764     local tarfile="$1"
765     shift
766     local extractfile="$@"
767
768     echo "Untarring ${tarfile##*/}..."
769     tar $(tarflags "$tarfile") "$tarfile" $extractfile
770
771 }
772
773 unpack_ofed() {
774         local ofed_type="$1"
775         local ofed_version="$2"
776         local distro_name="${DISTRO}"
777         local arch="${TARGET_ARCH}"
778         local file
779
780         #if a src tarball has been given in the command line, we use it
781         #The format of the directory after untar MUST be in OFED-${version}
782         #even if it's from MLNX or IFS...or whatever
783         if [ -n "${OFED_SRC}" ]; then
784                 if ! untar "$KERNELTREE/${OFED_SRC}"; then
785                         return 1
786                 else
787                         [ -d OFED ] || ln -sf OFED-[0-9].[0-9]* OFED
788                 fi
789         fi
790         case $ofed_type in
791                 ofa)
792                         file="OFED-${ofed_version}"
793                         if ! untar "$KERNELTREE/${file}.tgz"; then
794                                 return 1
795                         fi
796                         [ -d OFED ] || ln -sf OFED-[0-9].[0-9]* OFED
797                         ;;
798                 mlnx)
799                         # this is a work around for suse distro (sles11.3). what we need is
800                         # sles11sp3. We really need to redesign how we use target and distro
801                         [[ $distro_name =~ sles ]] && distro_name=${DISTRO/./sp}
802                         file="MLNX_OFED_LINUX-${ofed_version}-${distro_name}-${arch}"
803
804                         # it's not important what distro we get the tarball since we only
805                         # interest in the src
806                         if ! untar "$KERNELTREE/${file}.tgz"; then
807                                 return 1
808                         fi
809                         # we need to untar again to get the src since it's being
810                         # wrapped inside the tarball
811                         # There are cases where the source version is different
812                         # than the tarball.
813                         # (ie. MLNX_OFED_LINUX-2.3-1.0.1 but MLNX_OFED_SRC-2.3-1.0.0)
814                         local src=$(ls ${file}/src/MLNX_OFED_SRC-${ofed_version%.*}*.tgz)
815                         if ! untar "$src"; then
816                                 return 1
817                         fi
818                         [ -d OFED ] || ln -sf MLNX_OFED_SRC-[0-9].[0-9]* OFED
819                         ;;
820                 ifs)
821                         file="IntelIB-Basic.$(echo ${distro_name%%.*} | tr '[:lower:]' '[:upper:]')-${arch}.${ofed_version}"
822                         if ! untar "$KERNELTREE/${file}.tgz"; then
823                                 return 1
824                         fi
825                         [ -d OFED ] || ln -sf $file/IntelIB-OFED.$(echo ${distro_name%%.*} | tr '[:lower:]' '[:upper:]')-${arch}.* OFED
826                         ofed_version="$(cat OFED/Version)"
827                         ;;
828         esac
829         # version might change due to detect daily version
830         OFED_VERSION=${ofed_version}
831 }
832
833 unpack_lustre() {
834
835     untar "$LUSTRE" || fatal 1 "Error unpacking Lustre tarball"
836     [ -d lustre ] || ln -sf lustre-[0-9].[0-9]* lustre
837
838 }
839
840 do_patch_linux() {
841
842     local do_patch=${1:-true}
843
844     FULL_PATCH="$PWD/lustre-kernel-${TARGET}-${EXTRA_VERSION}.patch"
845     [ -f "$FULL_PATCH" ] && rm -f "$FULL_PATCH"
846     $do_patch && pushd linux >/dev/null
847     for series in $SERIES; do
848         echo -n "Applying series $series:"
849         for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
850             [ -r "$patchesdir/series/$series" ] || continue
851             SERIES_FILE="$patchesdir/series/$series"
852             for patch in $(<"$SERIES_FILE"); do
853                 echo -n " $patch"
854                 PATCH_FILE="$patchesdir/patches/$patch"
855                 [ -r "$PATCH_FILE" ] || \
856                     fatal 1 "Patch $patch does not exist in Lustre tree."
857                 cat "$PATCH_FILE" >> "$FULL_PATCH" || {
858                     rm -f $FULL_PATCH
859                     fatal 1 "Error adding patch $patch to full patch."
860                 }
861                 if $do_patch; then
862                     patch -s -p1 < "$PATCH_FILE" 2>&1 || {
863                         rm -f $FULL_PATCH
864                         fatal 1 "Error applying patch $patch."
865                     }
866                 fi
867             done
868             break
869         done
870         echo
871     done
872     $do_patch && popd >/dev/null
873     echo "Full patch has been saved in ${FULL_PATCH##*/}."
874
875 }
876
877 build_lustre() {
878     local linux="$1"
879     local linuxobj="$2"
880     local configure_args=""
881
882     cp "$LUSTRE" SOURCES
883
884     pushd lustre >/dev/null
885
886     if ! build_lustre_dkms; then
887         popd >/dev/null # pushd lustre
888         return 255
889     fi
890
891     echo "Building Lustre RPMs for: $TARGET_ARCH"
892
893     # If server we now build the spl and zfs modules against the lustre kernel.
894     # These are required prior to the building of lustre server. Client does
895     # not require spl/zfs. Use !PATCHLESS to indicate server which follows the
896     # line above so is at least consistant.
897     if [ $PATCHLESS == false ] && [ "x$WITH_ZFS" == "x" ]; then
898         if ! build_spl_zfs; then
899             popd >/dev/null # pushd lustre
900             return 255
901         fi
902     fi
903
904     if $PATCHLESS; then
905         configure_args="$configure_args --disable-server"
906     fi
907
908     # ditto for the lustre-tests boolean
909     if ! $LUSTRE_TESTS; then
910         configure_args="$configure_args --disable-tests"
911     fi
912
913     if ! $IOKITRPM; then
914         configure_args="$configure_args --disable-iokit"
915     fi
916
917     if ! $OSDZFSRPM; then
918         configure_args="$configure_args --without-zfs"
919     fi
920
921     if ! $OSDLDISKFSRPM; then
922         configure_args="$configure_args --disable-ldiskfs"
923     fi
924
925     configure_args="$configure_args --with-linux=$linux"
926     configure_args="$configure_args ${linuxobj:+--with-linux-obj=$linuxobj}"
927
928     # allow environment setting to override ldiskfs series selection
929     [ -n "$LDISKFS_SERIES" ] && export LDISKFS_SERIES
930
931     ./configure $configure_args $CONFIGURE_FLAGS 2>&1 ||
932         fatal 1 "Error in configure."
933
934     if type -p apply_kmod_requires_conflicts; then
935         apply_kmod_requires_conflicts
936     fi
937
938     make rpms 2>&1 ||
939         fatal 1 "Error building rpms for $TARGET_ARCH."
940
941     # move RPMs into place where they are expected to be
942     mv -f *lustre*.${TARGET_ARCH}.rpm $TOPDIR/RPMS/${TARGET_ARCH}/
943     mv -f lustre-*.src.rpm $TOPDIR/SRPMS/
944
945     popd >/dev/null
946         if type -p cleanup_rpmmacros; then
947                 cleanup_rpmmacros
948         fi
949
950     return 0
951 }
952
953 # Only zfs Lustre DKMS Server is supported
954 build_lustre_dkms() {
955     local build_args=""
956     local name_prefix="lustre"
957     local ver=$(sed -n -e 's/^LUSTRE_VERSION = //p' LUSTRE-VERSION-FILE)
958
959     echo "Building Lustre DKMS RPMs for: $TARGET_ARCH"
960     ./configure --enable-dist || fatal 1 "Error in DKMS configure."
961
962     if $PATCHLESS; then
963         build_args="--without servers"
964         name_prefix="lustre-client"
965     fi
966
967     rpmbuild --define "_topdir $TOPDIR" $build_args -bs lustre-dkms.spec ||
968         fatal 1 "Error building DKMS .src.rpm for $TARGET_ARCH."
969     rpmbuild --define "_topdir $TOPDIR" $build_args \
970              --rebuild $TOPDIR/SRPMS/$name_prefix-dkms-$ver-*.src.rpm ||
971         fatal 1 "Error building DKMS .rpm for $TARGET_ARCH."
972
973     return 0
974 }
975
976 ###
977 # build_spl_zfs
978 #
979 # Fetch spl/zfs from the git repo and prepare for lustre build
980 #
981 # Overrides:
982 #   SPLZFSGITREPO - URI of directory where spl.git and zfs.git are located
983 #   SPLZFSTAG     - Tag to checkout of clone repositories
984 #   SPLZFSVER     - Version to checkout of both (format zfs/spl-$SPLZFSVER)
985 #
986 # return 0 if successful, else 255
987 build_spl_zfs() {
988     # make sure the RPM build environment is set up
989     pushd $TOPDIR
990     create_rpmbuild_dirs
991     popd
992
993     # The spl/zfs spec files expect RPM_BUILD_ROOT to point to the root of the
994     # destination for the rpms
995     export RPM_BUILD_ROOT=$TOPDIR
996     SPLZFSVER=${SPLZFSVER:-0.7.1}
997     SPLZFSTAG=${SPLZFSTAG:-}
998
999     # The files expect a kver to be set to the kernel version .
1000     local kver=$(find_linux_release)
1001
1002     # build and install the spl and zfs (and -devel) RPMs for lustre to use
1003     local pkg
1004     for pkg in spl zfs; do
1005
1006         local rpmpkg
1007
1008         [ "$pkg" == "zfs" ] && spldir="$(ls -d $TOPDIR/usr/src/spl-*|tail -1)"
1009
1010         # need to fetch the repo in order to build it.
1011         # default to github but allow override
1012         git clone -n ${SPLZFSGITREPO:-"https://github.com/zfsonlinux"}/$pkg.git $pkg 2>&1
1013
1014         pushd $pkg || return 255
1015         local tag
1016         if [ -n "$SPLZFSTAG" ]; then
1017             tag=$SPLZFSTAG
1018         else
1019             tag=$pkg-$SPLZFSVER
1020         fi
1021         git checkout -b lbuild $tag || fatal 1 "Failed to checkout \"$tag\" for $pkg.git"
1022
1023         # This differentiates between older zfs versions
1024         if [ -f $pkg-modules.spec.in ]; then
1025             rpmpkg=$pkg-modules
1026             specdir=.
1027             speclist="$pkg.spec $rpmpkg.spec"
1028         else
1029             rpmpkg=kmod-$pkg-devel
1030             specdir=rpm/generic
1031             speclist="$pkg.spec $pkg-kmod.spec $pkg-dkms.spec"
1032         fi
1033
1034         sh autogen.sh || return 255
1035
1036         if  ! ./configure --with-linux=${LINUX} --with-linux-obj=${LINUXOBJ:-$LINUX} \
1037                           ${spldir:+--with-spl="${spldir}"} 2>&1 ||
1038             ! make dist 2>&1; then
1039             popd
1040             return 255
1041         fi
1042         popd
1043
1044         ln -f $pkg/$pkg-*.tar.gz $TOPDIR/SOURCES ||
1045            error "failed to link $pkg/$pkg-*.tar.gz into $TOPDIR/SOURCES"
1046         if [ -f $pkg/scripts/kmodtool ]; then
1047             ln -f $pkg/scripts/kmodtool $TOPDIR/SOURCES/
1048         fi
1049
1050         local rpmb
1051         if $DO_SRC; then
1052             rpmb=-ba
1053         else
1054             rpmb=-bb
1055         fi
1056
1057         # set search dir for our own kmodtool to find correct
1058         # directories
1059         export KERNELSOURCE=$(dirname ${LINUX})
1060         # Manually build rpms
1061         for spec in $speclist; do
1062             echo "Building RPMs from $pkg/$specdir/$spec"
1063             if ! rpmbuild $rpmb $pkg/$specdir/$spec \
1064                 --nodeps -v \
1065                 --define "_use_internal_dependency_generator 0" \
1066                 --define "require_kdir ${LINUX}" \
1067                 ${LINUXOBJ:+--define "require_kobj ${LINUXOBJ}"} \
1068                 ${spldir:+--define "require_spldir ${spldir}"} \
1069                 --define "kver $kver" \
1070                 --define "kernels $kver" \
1071                 --define "_tmppath /var/tmp" \
1072                 --define "kernelbuildroot $TOPDIR/reused" \
1073                 --define "_topdir $TOPDIR" 2>&1; then
1074                 return 255
1075             fi
1076         done
1077
1078         # We have built the rpms for the package. Now we need to extract the
1079         # contained files so we can build further things against them
1080         local rpms=$(ls -1 $TOPDIR/RPMS/*/$rpmpkg-*.rpm)
1081
1082         # cpio only extract to pwd so we need to go there.
1083         pushd $TOPDIR
1084         local rpm
1085         for rpm in $rpms; do
1086             rpm2cpio $rpm | cpio -id
1087         done
1088
1089         if [ "$pkg" == "zfs" ]; then
1090             # We also need to extract both the zfs and zfs-devel rpms
1091             # the zfs rpm is needed because it has the actual libraries in
1092             # it and the zfs-devel rpm only has unversioned symlinks to the
1093             # libraries in the zfs rpm
1094             # this will all change one day when we have a libzfs rpm per
1095             # https://github.com/zfsonlinux/zfs/issues/2329
1096             # and it looks like it could be one day soon:
1097             # https://github.com/zfsonlinux/zfs/pull/2341
1098             local devel_rpms=$(ls -1 $TOPDIR/RPMS/*/{$pkg-devel,$pkg-$SPLZFSVER,lib*}-*.rpm)
1099             for rpm in $devel_rpms; do
1100                 rpm2cpio $rpm | cpio -id
1101             done
1102             CONFIGURE_FLAGS="--with-$pkg-devel=$TOPDIR ${CONFIGURE_FLAGS}"
1103         fi
1104         popd
1105
1106         CONFIGURE_FLAGS="--with-$pkg=$(ls -d $TOPDIR/usr/src/$pkg-*|tail -1) ${CONFIGURE_FLAGS}"
1107         CONFIGURE_FLAGS="--with-$pkg-obj=$(ls -d $TOPDIR/usr/src/$pkg-*/$kver*|tail -1) ${CONFIGURE_FLAGS}"
1108     done
1109
1110     OSDZFSRPM=true
1111
1112     return 0
1113 }
1114
1115 stage() {
1116
1117     [ "$STAGEDIR" ] || return 0
1118
1119     rpmdir="${STAGEDIR}/${CANONICAL_TARGET}-${TARGET_ARCH}"
1120     echo "${0##*/}: Copying RPMs into ${rpmdir}"
1121     mkdir -p "${rpmdir}"
1122     for rpm in $(ls RPMS/${TARGET_ARCH}/*.rpm RPMS/noarch/*.rpm); do
1123         cp -v $rpm "${rpmdir}"
1124     done
1125
1126     cp -v "$LUSTRE" "$STAGEDIR"
1127
1128 }
1129
1130 set_rpm_smp_type() {
1131
1132     local infact_arch="${TARGET_ARCH}"
1133
1134     RPMSMPTYPE=""
1135     [ "$infact_arch" == "i586" ] && infact_arch="i686"
1136
1137     local smp_type
1138     for smp_type in $SMP_ARCHS; do
1139         [ $infact_arch == $smp_type ] && RPMSMPTYPE=smp && break
1140     done
1141
1142     for smp_type in $BIGSMP_ARCHS; do
1143         [ $infact_arch == $smp_type ] && RPMSMPTYPE=bigsmp && break
1144     done
1145
1146     for smp_type in $PPC64_ARCHS; do
1147         [ $infact_arch == $smp_type ] && RPMSMPTYPE=ppc64 && break
1148     done
1149
1150     for smp_type in $DEFAULT_ARCHS; do
1151         [ $infact_arch == $smp_type ] && RPMSMPTYPE=default && break
1152     done
1153
1154 }
1155
1156 # This function takes a linux include tree and digs out the linux release
1157 # from it. It is never called directly, only called from the distro
1158 # specific function find_linux_release() in lbuild-{rhel,sles}.
1159 _find_linux_release() {
1160     local SRC="$1"
1161     local LINUXRELEASEHEADER=""
1162
1163     LINUXRELEASEHEADER=$SRC/include/linux/version.h
1164     if [ -s $SRC/include/generated/utsrelease.h ]; then
1165         LINUXRELEASEHEADER=$SRC/include/generated/utsrelease.h
1166     elif [ -s $SRC/include/linux/utsrelease.h ]; then
1167         LINUXRELEASEHEADER=$SRC/include/linux/utsrelease.h
1168     fi
1169
1170     if [ ! -s $LINUXRELEASEHEADER ]; then
1171         fatal 1 "could not find UTS_RELEASE"
1172     fi
1173
1174     sed -ne 's/#define UTS_RELEASE "\(.*\)"$/\1/p' $LINUXRELEASEHEADER
1175 }
1176
1177 # unpack kernel(/source/devel) RPM
1178 #
1179 unpack_linux_devel_rpm() {
1180     local kernelrpm="${1}"
1181
1182     [ -f "$kernelrpm" ] || return 255
1183     [ -d $TOPDIR/reused ] || mkdir $TOPDIR/reused || return 255
1184
1185     pushd $TOPDIR/reused &>/dev/null || return 255
1186
1187     if ! rpm2cpio < "$kernelrpm" | cpio -id > /dev/null 2>&1; then
1188         return 255
1189     fi
1190
1191     # call a distro specific hook, if available
1192     if type -p unpack_linux_devel_rpm-$DISTROMAJ; then
1193         if ! unpack_linux_devel_rpm-$DISTROMAJ "$kernelrpm"; then
1194             return 255
1195         fi
1196     fi
1197
1198     popd &>/dev/null
1199
1200     find_linux_devel_paths $TOPDIR/reused
1201
1202     return 0
1203
1204 }
1205
1206 build_kernel_ib() {
1207     local linux="$1"
1208     local kib_prefix="$2"
1209     local kib_rpm="$3"
1210     local ofed_type="${4}"
1211     local ofed_version="${5}"
1212
1213     # build kernel-ib{,-devel}/compat-rdma{,-devel}
1214     local K_SRC="K_SRC"
1215
1216         local OFED_CORE="--with-core-mod --with-ipoib-mod --with-user_mad-mod \
1217         --with-user_access-mod --with-addr_trans-mod --with-madeye-mod"
1218         local OFED_HARDWARE="--with-mthca-mod --with-mlx4-mod \
1219         --with-mlx4_en-mod --with-cxgb3-mod --with-mlx4_en-mod \
1220         --with-cxgb3-mod --with-nes-mod --with-mlx5-mod --with-cxgb4-mod \
1221         --with-qib-mod"
1222
1223         # Removing the check for older version support
1224         #if compare_version $OFED_VERSION 3.0; then
1225         #OFED_CORE="$OFED_CORE --with-madeye-mod --with-rds-mod"
1226         #else
1227         #OFED_HARDWARE="$OFED_HARDWARE --with-mlx5-mod --with-cxgb4-mod --with-ocrdma-mod --with-qib-mod"
1228         #fi
1229
1230     # some I/B drivers are architecture dependent and kernel-ib's configure
1231     # does not figure it out for us ~sigh~
1232     case "$TARGET_ARCH" in
1233         ppc64)
1234             OFED_HARDWARE="$OFED_HARDWARE --with-ehca-mod"
1235             ;;
1236     esac
1237     # we're no longer shipping the OFED iSCSI target
1238     #OFED_ISCSI="--with-srp-mod --with-srp-target-mod"
1239     OFED_ISCSI="--with-srp-mod"
1240     ## ISER module has no backport support as of OFED 1.5 (i.e. only builds on
1241     ##kernels >= 2.6.30)
1242     #if [[ $OFED_VERSION = 1.[0-4]* ]]; then
1243     #   OFED_ISCSI="$OFED_ISCSI --with-iser-mod"
1244     #fi
1245
1246     # assume we are just rebuilding the SRPM
1247     local BUILD_TYPE=${BUILD_TYPE:-"--rebuild"}
1248     local SOURCE="${TOPDIR}/OFED/SRPMS/${kib_prefix}-*.src.rpm"
1249
1250     # but switch to building from the SPEC if we need to apply patches
1251     if ls ${TOPDIR}/lustre/contrib/patches/ofed/* >/dev/null; then
1252         BUILD_TYPE="-bb"
1253         rpm --define "_topdir ${TOPDIR}" -ivh $SOURCE
1254         SOURCE="${TOPDIR}/SPECS/${kib_prefix}.spec"
1255         local file ed_fragment1 ed_fragment2 n=1
1256         for file in $(ls ${TOPDIR}/lustre/contrib/patches/ofed/*.patch); do
1257             ed_fragment1="$ed_fragment1
1258 Patch$n: ${file%%*/}"
1259             ed_fragment2="$ed_fragment2
1260 %patch$n -p0"
1261             cp $file ${TOPDIR}/SOURCES
1262             let n=$n+1
1263         done
1264         for file in $(ls ${TOPDIR}/lustre/contrib/patches/ofed/*.ed); do
1265             # Only apply the ed-scripts that should be used for the canonical target
1266             # ed-files in ${TOPDIR}/lustre/contrib/patches/ofed/ have to follow the naming
1267             # convention
1268             # <two-digits>-<descriptive-name>:<canonical_target_1>: ...:<canonical_target_N>.ed
1269             # To apply the same change to multiple canonical target simply specify
1270             # a list of colon separated canoncial target names in the file name.
1271             echo "$file" | grep -q -e ":${CANONICAL_TARGET}:" \
1272                                    -e ":${CANONICAL_TARGET}.ed$"
1273             if [ $? -eq 0 ] ; then
1274                 ed_fragment3="$ed_fragment3
1275 $(cat $file)"
1276                 let n=$n+1
1277             fi
1278         done
1279
1280         if [ $n -gt 1 ]; then
1281             ed $SOURCE <<EOF
1282 /^Source: /a
1283 $ed_fragment1
1284 .
1285 /^%setup /a
1286 $ed_fragment2
1287 .
1288 $ed_fragment3
1289 wq
1290 EOF
1291         fi
1292     fi
1293
1294     local linuxrelease=$(find_linux_release)
1295         # a place to change/add any unique config
1296         case $ofed_type in
1297                 ofa|ifs) local K_SRC_OBJ="K_SRC_OBJ"
1298                 if ! $RPMBUILD $BUILD_TYPE --define 'build_kernel_ib 1' \
1299                         --define 'build_kernel_ib_devel 1' \
1300                         ${FIND_REQUIRES:+--define "__find_requires $FIND_REQUIRES"} \
1301                         --define "_topdir ${TOPDIR}" --target ${TARGET_ARCH} \
1302                         --define "KVERSION ${linuxrelease}" \
1303                         --define "$K_SRC ${linux}" \
1304                         ${K_SRC_OBJ:+--define "$K_SRC_OBJ ${linux}"} \
1305                         ${OFA_KERNEL_RELEASE:+--define "_release $OFA_KERNEL_RELEASE"} \
1306                         --define "configure_options --without-quilt $OFED_CORE $OFED_HARDWARE $OFED_ISCSI" \
1307                         ${SOURCE} 2>&1; then
1308                         fatal 1 "Error building ${kib_rpm}"
1309                 fi
1310                 ;;
1311                 mlnx)
1312                 if ! $RPMBUILD $BUILD_TYPE \
1313                         ${FIND_REQUIRES:+--define "__find_requires $FIND_REQUIRES"} \
1314                         --define "_topdir ${TOPDIR}" --target ${TARGET_ARCH} \
1315                         --define "KVERSION ${linuxrelease}" \
1316                         --define "$K_SRC ${linux}" \
1317                         ${OFA_KERNEL_RELEASE:+--define "_release $OFA_KERNEL_RELEASE"} \
1318                         --define "configure_options --without-quilt $OFED_CORE $OFED_HARDWARE $OFED_ISCSI" \
1319                         ${SOURCE} 2>&1; then
1320                         fatal 1 "Error building ${kib_rpm}"
1321                 fi
1322                 ;;
1323         esac
1324
1325 }
1326
1327 store_for_reuse() {
1328     local articles="$1"
1329     local module="$2"
1330     local location="$3"
1331     local signature="$4"
1332     local use_links="$5"
1333
1334     local linkflag=""
1335     if $use_links; then
1336         linkflag="l"
1337     fi
1338
1339     local default_iface=$(/sbin/ip route get 192.1.1.1 | sed -ne 's/.* dev \(.*\)  * src .*/\1/p')
1340     if [ -z "$default_iface" ]; then
1341         fatal 1 "Failed to determine the default route interface"
1342     fi
1343     local unique_id=$(/sbin/ip addr show dev $default_iface | sed -ne '/ inet /s/ *inet \(.*\)\/.*/\1/p' | head -1)
1344     if [ -z "$unique_id" ]; then
1345         fatal 1 "Failed to determine a unique id from interface $default_interface"
1346     fi
1347
1348     local finallocation="$location"/"$signature"/"$module"
1349     location="$location"/"$signature-${unique_id}"/"$module"
1350     mkdir -p "$location"
1351     # the cleanup script removes any directory that doesn't have a
1352     # .lastused, so let's try to prevent that as soon as we can
1353     # this solution still slightly racy with the cleanup script
1354     # but the race is a lot tighter now
1355     touch -t 197001010000 "$location/.lastused"
1356     ## use eval/echo here to make sure shell expansions are performed
1357     #if ! cp -a${linkflag} $(eval echo $articles) "$location"; then
1358     local article
1359     for article in $(eval echo $articles); do
1360         if ! cp -a${linkflag} "$article" "$location"; then
1361             error "Failed to copy \"$article\" to \"$location\" in store_for_reuse()"
1362             # rename the cache location so that it's not cached
1363             # product, but is around for analysis
1364             mv "$location"{,-bad-$(date +%s)} ||
1365                 error "failed to clean up a failed cache attempt" \
1366                       "in \"$location\" -- manual cleanup will be" \
1367                       "necessary"
1368             return 1
1369         fi
1370     done
1371
1372     # flag the cache as complete (i.e. in case lbuild was previously
1373     # interrupted while caching)
1374     touch "$location/.lastused"
1375
1376     # put the temporary location into the final location
1377     # (last one wins)
1378     mkdir -p "${finallocation%/*}"
1379     mv "$location" "$finallocation"
1380     rmdir "${location%/*}"
1381     return 0
1382
1383 }
1384
1385 reuse() {
1386     local module="$1"
1387     local dest="$2"
1388     local use_links="${3:-false}"
1389     local signature="$4"
1390
1391     if [ -n "$REUSEBUILD" ] && [ -d "$REUSEBUILD/$signature/$module" ]; then
1392         if [ ! -f "$REUSEBUILD/$signature/$module/.lastused" ]; then
1393             # the .lastused flag is populated at the end of the caching to
1394             # signal that the caching was completed.  if that flag is not
1395             # there, then the cache is invalid (and should be removed in fact)
1396             mv "$REUSEBUILD/$signature/$module"{,-bad-$(date +%s)} ||
1397                 fatal 1 "failed to clean up a bad cache in location $REUSEBUILD/$signature/$module\" -- manual cleanup will be necessary"
1398             return 1
1399         fi
1400
1401         # so that we know how stale this entry is
1402         touch $REUSEBUILD/$signature/$module/.lastused
1403
1404         if $use_links; then
1405             if ls $REUSEBUILD/$signature/$module/* >/dev/null 2>&1; then
1406                 cp -al $REUSEBUILD/$signature/$module/* $dest/
1407             fi
1408         else
1409             # copying is pretty heavy
1410             # cp -a $REUSEBUILD/$signature/$module/* $dest/
1411             # do some creative symlinking instead
1412             local dir
1413             for dir in BUILD SRPMS SPECS; do
1414                 if ls $REUSEBUILD/$signature/$module/$dir/* >/dev/null 2>&1; then
1415                     ln -s $REUSEBUILD/$signature/$module/$dir/* $dest/$dir
1416                 fi
1417             done
1418             # sources have to be copied by file because we need SOURCES to
1419             # be a dir we can write into
1420 # could overrun ls's arg list here
1421             #ls $REUSEBUILD/$signature/$module/SOURCES/* |
1422             find $REUSEBUILD/$signature/$module/SOURCES/ -type f |
1423                 xargs ln -t $dest/SOURCES -s
1424
1425             # same for RPMS/* dirs
1426 # could overrun ls's arg list here
1427             #ls $REUSEBUILD/$signature/$module/RPMS/$TARGET_ARCH/* |
1428             local dir
1429             for dir in $REUSEBUILD/$signature/$module/RPMS/*; do
1430                 mkdir -p $dest/RPMS/${dir##*/}
1431                 find $dir -type f |
1432                   xargs ln -t $dest/RPMS/${dir##*/} -s
1433             done
1434         fi
1435         return 0
1436     else
1437         return 1
1438     fi
1439 }
1440
1441 basearch() {
1442     local arch="$1"
1443
1444     if [[ $arch = i[3456]86 ]]; then
1445         echo "i386"
1446     else
1447         echo "$arch"
1448     fi
1449
1450 }
1451
1452 build_kernel_with_srpm() {
1453     local outfd=$1
1454
1455     if [ -z "$outfd" ] || [ $outfd = 1 ]; then
1456         fatal 1 "You must supply a file descriptor to ${FUNCNAME[0]} and it cannot be 1"
1457     fi
1458
1459     # need to generate the patch for this target
1460     do_patch_linux false >&${outfd}    # sets global $FULL_PATCH (yeah, yuck)
1461
1462     # get an md5sum of the kernel patch + config for reuse check
1463     local release_str
1464     if $RELEASE; then
1465         local release_str="RELEASE=$RELEASE\n"
1466     fi
1467
1468     if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1469         local REUSE_SIGNATURE=$({ echo -en $release_str;
1470                                   echo $BUILD_GEN;
1471                                   cat "$CONFIG_FILE";
1472                                   cat "$TARGET_FILE" |
1473                                   sed -e '/_VERSION=/s/_[0-9]*_g.*$//g';
1474                                   cat "$FULL_PATCH";
1475                                   cat "$LBUILD_DIR/lbuild";
1476                                   cat "$LBUILD_DIR/lbuild-$DISTROMAJ"; } |
1477                                 md5sum | cut -d" " -f1)
1478         # see if we can link to the reuse pool
1479         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse
1480         #       "library"
1481         local CAN_LINK_FOR_REUSE=false
1482         touch $REUSEBUILD/$$
1483         if cp -al $REUSEBUILD/$$ $TOPDIR/ 2>/dev/null; then
1484             CAN_LINK_FOR_REUSE=true
1485         fi
1486         rm $REUSEBUILD/$$
1487     fi
1488
1489     # the extra version string to use for the kernel (which might be a reused
1490     # kernel, remember)
1491     local kernel_extra_version=""
1492     if ! $USE_BUILD_CACHE || ! reuse kernel "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1493                                    "$REUSE_SIGNATURE"; then
1494         # nothing cached, build from scratch
1495         echo "Downloading kernel SRPM" >&${outfd}
1496         download_srpm "$CANONICAL_TARGET" "$KERNEL_SRPM" >&${outfd}
1497
1498         if ! rpm -ivh $KERNELDIR/$KERNEL_SRPM \
1499                   --define "_topdir $TOPDIR" >&${outfd} 2>&1; then
1500             # should we clean this up or leave it for analysis?
1501             #rm -rf $RPMTOPDIR
1502             fatal 1 "Error installing kernel SRPM."
1503         fi
1504
1505         # put the Lustre kernel patch into the RPM build tree
1506         cp $FULL_PATCH $TOPDIR/SOURCES/linux-${lnxmaj}-lustre.patch
1507         prepare_and_build_srpm >&${outfd} ||
1508             fatal 1 "failed to prepare_and_build_srpm"
1509
1510         if [ -z "$REUSE_SIGNATURE" ]; then
1511             echo "No reuse signature was caculated so not storing the built kernel" >&${outfd}
1512         else
1513             # store the resulting kernel RPM build tree for future use
1514             echo "Storing the built kernel for future reuse" >&${outfd}
1515             if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,SRPMS,RPMS}" \
1516                                  "kernel" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1517                                  "$CAN_LINK_FOR_REUSE"; then
1518                 error "Failed to store kernel RPMS for reuse"
1519                 echo "unknown" >&${outfd}
1520                 return 1
1521             fi
1522         fi
1523     fi  # build reuse
1524
1525     # figure out the EXTRA_VERSION of the kernel we built or are re-using
1526     local KERNEL_RPM
1527     if ! KERNEL_RPM=$(find_rpm "$TOPDIR/RPMS/$TARGET_ARCH/" provides "^kernel(-default)? ="); then
1528         fatal 1 "Failed to find a kernel RPM in $TOPDIR/RPMS/$TARGET_ARCH/"
1529     fi
1530     kernel_extra_version=$(rpm -q --queryformat "%{RELEASE}" -p $TOPDIR/RPMS/$TARGET_ARCH/$KERNEL_RPM)
1531
1532     # should now have the following RPMs
1533     # $TOPDIR/RPMS/$arch/kernel-lustre-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1534     # $TOPDIR/RPMS/$arch/kernel-lustre-devel-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1535     # $TOPDIR/RPMS/$arch/kernel-lustre-headers-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1536     # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-common-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1537     # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1538
1539     echo $kernel_extra_version
1540     return 0
1541
1542 }
1543
1544 # build OFED
1545 # globals used:
1546 #    TOPDIR
1547 #    REUSEBUILD, USE_BUILD_CACHE
1548 #    CONFIGURE_FLAGS
1549
1550 build_ofed() {
1551         local linux="$1"
1552         local ofed_type="$2"
1553         local ofed_version="$3"
1554         local kib_prefix
1555         local kib_rpm
1556         local pre_prefix
1557         local o2ib_location
1558         local rpm
1559
1560     if [ "$ofed_version" = "inkernel" ]; then
1561         # see if there is a distro specific override for this and use
1562         # that if it exists
1563         # XXX we need to better integrate a distro specific override with
1564         #     the rest of this function so that all of the reuse cache
1565         #     stuff is leveraged given that 80% of this function is reuse
1566         if type -p build_ofed-$DISTROMAJ; then
1567             local ofed_location
1568             ofed_location=$(build_ofed-$DISTROMAJ ${STDOUT})
1569             local rc=${PIPESTATUS[0]}
1570             CONFIGURE_FLAGS="--with-o2ib=${ofed_location} ${CONFIGURE_FLAGS}"
1571             return $rc
1572         else
1573             return 0
1574         fi
1575         else
1576                 case $ofed_type in
1577                         mlnx) # no compat-rdma for mlnx as of 3.1
1578                                 kib_prefix="ofa_kernel"
1579                                 pre_prefix="mlnx-"
1580                                 kib_rpm="${pre_prefix}${kib_prefix}"
1581                                 ;;
1582                         ofa|ifs)
1583                                 if compare_version $ofed_version 3.0; then
1584                                         kib_prefix="ofa_kernel"
1585                                         kib_rpm="${pre_prefix}${kib_prefix}"
1586                                 else
1587                                         kib_prefix="compat-rdma"
1588                                         kib_rpm="compat-rdma"
1589                                 fi
1590                                 ;;
1591                 esac
1592         fi
1593
1594     # build kernel-ib/compat-rdma
1595     if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1596         local REUSE_SIGNATURE=$({ echo "$ofed_version";
1597                                   echo "$(find_linux_release;
1598                                   echo "$BUILD_GEN")";
1599                                   cat "${linux}/include/linux/autoconf.h";
1600                                   cat "$LBUILD_DIR/lbuild";
1601                                   cat "$LBUILD_DIR/lbuild-$DISTROMAJ"; } |
1602                                 md5sum | cut -d" " -f1)
1603         # see if we can link to the reuse pool
1604         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse
1605         #       "library"
1606         local CAN_LINK_FOR_REUSE=false
1607         touch $REUSEBUILD/$$
1608         if cp -al $REUSEBUILD/$$ $TOPDIR/; then
1609             CAN_LINK_FOR_REUSE=true
1610         fi
1611         rm $REUSEBUILD/$$
1612     fi
1613
1614     if ! $USE_BUILD_CACHE || ! reuse ofed "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1615                                    "$REUSE_SIGNATURE"; then
1616         if [ -n "$REUSE_SIGNATURE" ]; then
1617             # stash away the existing built articles for a moment
1618             mkdir bak
1619             mv {BUILD,{S,}RPMS,S{OURCE,PEC}S} bak
1620             function mv_back {
1621                 pushd bak
1622                 find . | cpio -pudlm ..
1623                 popd
1624                 rm -rf bak
1625             }
1626             create_rpmbuild_dirs
1627         fi
1628         # build it
1629         build_kernel_ib "${linux}" "${pre_prefix}${kib_prefix}" "${kib_rpm}" "${ofed_type}"
1630
1631         if [ -z "$REUSE_SIGNATURE" ]; then
1632             echo "No reuse signature was caculated so not storing the built ofed"
1633         else
1634             # store the resulting RPM build tree for future use
1635             echo "Storing the built ofed for future reuse"
1636             if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,BUILD,SRPMS,RPMS}" \
1637                                  "ofed" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1638                                  "$CAN_LINK_FOR_REUSE"; then
1639                 error "Failed to store OFED RPMS for reuse"
1640                 mv_back
1641                 return 1
1642             fi
1643             # put the stuff we stashed away back
1644             mv_back
1645         fi
1646     fi
1647
1648     pushd "$TOPDIR" >/dev/null
1649     rm -rf ${kib_rpm}-devel
1650     mkdir ${kib_rpm}-devel
1651     cd ${kib_rpm}-devel
1652
1653         o2ib_location="$(pwd)/usr/src/${kib_prefix}"
1654         case $ofed_type in
1655                 mlnx) # Prior to MOFED 3.1, we had to use build_kernel_ib=1 to
1656                       # build devel rpm. not so after 3.1
1657                         if compare_version $ofed_version 3.0; then
1658                                 rpm=$(ls $TOPDIR/RPMS/*/kernel-ib-devel-${ofed_version%%-*}-*.rpm)
1659                         else
1660                                 rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-${ofed_version%%-*}-*.rpm)
1661                         fi
1662                         o2ib_location="${o2ib_location}/default"
1663                         ;;
1664                 ofa) # Prior to OFA 3.18, we had to use build_kernel_ib=1 during configure,
1665                      # not so after 3.18
1666                         if compare_version $ofed_version 3.18; then
1667                                 rpm=$(ls $TOPDIR/RPMS/*/kernel-ib-devel-${ofed_version%%-*}-*.rpm)
1668                         else
1669                                 rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-${ofed_version%%-*}-*.rpm)
1670                         fi
1671                         ;;
1672                 ifs) # ifs doesn't follow any convention (if any)
1673                         rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-*.rpm)
1674                         ;;
1675         esac
1676
1677         if ! rpm2cpio < $rpm | cpio -id; then
1678                 fatal 1 "could not unpack the $rpm."
1679         fi
1680         CONFIGURE_FLAGS="--with-o2ib=${o2ib_location} ${CONFIGURE_FLAGS}"
1681         popd >/dev/null
1682
1683 }
1684
1685 build_with_srpm() {
1686         local ofed_type="$1"
1687         local ofed_version="$2"
1688         local kernelrpm
1689
1690         if ! $PATCHLESS; then
1691                 if $PATCHLESS_SERVER; then
1692                         # need to find and unpack the vendor's own kernel-devel
1693                         # for patchless server build
1694                         if ! kernelrpm=$(find_linux_rpm "-$DEVEL_KERNEL_TYPE"); then
1695                                 fatal 1 "Could not find the kernel-$DEVEL_KERNEL_TYPE RPM in $KERNELRPMSBASE/$lnxmaj/$DISTROMAJ"
1696                         fi
1697                         if ! lnxrel="$lnxrel" unpack_linux_devel_rpm "$kernelrpm" "-"; then
1698                                 fatal 1 "Could not find the Linux tree in $kernelrpm"
1699                         fi
1700                         # download and unpack kernel-debuginfo-common (only in EL)
1701                         if [[ $DISTROMAJ =~ rhel ]]; then
1702                                 local KERNEL_DEBUGINFO="kernel-debuginfo-common-${TARGET_ARCH}-${lnxmaj}-${lnxrel}.${TARGET_ARCH}.rpm"
1703                                 download_debuginfo_common "$KERNEL_DEBUGINFO"
1704                                 if ! lnxrel="$lnxrel" unpack_linux_devel_rpm \
1705                                         "$KERNELRPMSBASE/$lnxmaj/$DISTROMAJ/$TARGET_ARCH/$KERNEL_DEBUGINFO"; then
1706                                         fatal 1 "Could not find the Linux debuginfo common rpm in $KERNELRPMSBASE/$lnxmaj/$DISTROMAJ/$TARGET_ARCH/$KERNEL_DEBUGINFO"
1707                                 fi
1708                         fi
1709                 else
1710                         local kernel_extra_version
1711                         if ! kernel_extra_version=$(build_kernel_with_srpm ${STDOUT}); then
1712                                 fatal 1 "Failed to build the kernel from it's SRPM"
1713                         fi
1714
1715                         local kernel_devel_rpm
1716                         if ! kernel_devel_rpm=$(find_rpm "$TOPDIR/RPMS/${TARGET_ARCH}/" provides "^$(devel_kernel_name $KERNEL_LUSTRE_NAMING) ="); then
1717                                 fatal 1 "Failed to find a kernel development RPM in $TOPDIR/RPMS/${TARGET_ARCH}/"
1718                         fi
1719
1720                         # install the -devel RPM in preparation for modules builds
1721                         if ! lnxrel="$kernel_extra_version" unpack_linux_devel_rpm \
1722                                 "$TOPDIR/RPMS/${TARGET_ARCH}/$kernel_devel_rpm"; then
1723                                 fatal 1 "Could not find the Linux tree in $TOPDIR/RPMS/${TARGET_ARCH}/$kernel_devel_rpm"
1724                         fi
1725                 fi
1726         else
1727                 # need to find and unpack the vendor's own kernel-devel for patchless
1728                 # client build
1729                 if ! kernelrpm=$(find_linux_rpm "-$DEVEL_KERNEL_TYPE"); then
1730                         fatal 1 "Could not find the kernel-$DEVEL_KERNEL_TYPE RPM in $KERNELRPMSBASE/$lnxmaj/$DISTROMAJ"
1731                 fi
1732                 if ! lnxrel="$lnxrel" unpack_linux_devel_rpm "$kernelrpm" "-"; then
1733                         fatal 1 "Could not find the Linux tree in $kernelrpm"
1734                 fi
1735         fi
1736
1737     # ~sigh~  have to make copies of and modify some of the rpm
1738     # infrastructure files so that find-requires can find our unpacked
1739     # kernel-devel artifacts
1740     cp $RPM_HELPERS_DIR/{symset-table,find-requires{,.ksyms}} .
1741     export FIND_REQUIRES="$(pwd)/find-requires"
1742     chmod 755 {symset-table,find-requires{,.ksyms}}
1743     local tmp="$(pwd)"
1744     tmp="${tmp//\//\\/}"
1745     ed find-requires <<EOF
1746 1a
1747 set -x
1748 .
1749 /|.*find-requires.ksyms/s/|/| bash -x/
1750 g/ [^ ]*\/\(find-requires\.ksyms\)/s// $tmp\/\1/g
1751 wq
1752 EOF
1753     ed find-requires.ksyms <<EOF
1754 1a
1755 set -x
1756 .
1757 g/\/.*\/\(symset-table\)/s//$tmp\/\1/g
1758 g/\(\/usr\/src\/kernels\/\)/s//$tmp\/reused\1/g
1759 wq
1760 EOF
1761     ed symset-table <<EOF
1762 1a
1763 set -x
1764 .
1765 g/\(\/boot\/\)/s//$tmp\/reused\1/g
1766 g/\(\/usr\/src\/kernels\/\)/s//$tmp\/reused\1/g
1767 wq
1768 EOF
1769
1770         build_ofed "${LINUXOBJ:-$LINUX}" "$ofed_type" "$ofed_version" ||
1771         fatal 1 "error building OFED"
1772
1773     # now build Lustre
1774     if build_lustre "$LINUX" "$LINUXOBJ"; then
1775         # the build worked.  resolve any symlinked files (i.e. from reuse)
1776         # in RPMS/$arch to real files so that that that huge mess of
1777         # complication known as LTS can copy them yet somewhere else.
1778         # is it any wonder this whole process is so damn so?  anyone ever
1779         # heard of hardlinks?  it's this cool new thing that allows you save
1780         # tons of time and space by creating... well you can go read about
1781         # them if you have not heard about them yet.
1782         # can i say how much the implemenation of all of this really impedes
1783         # RPM reuse?
1784         local dir
1785         for dir in RPMS/*; do
1786             pushd $dir
1787             for file in $(ls); do
1788                 if [ -h $file ]; then
1789                     cp $file foo
1790                     mv foo $file
1791                 fi
1792             done
1793             popd
1794         done
1795         # also, for i?86, make sure all of the RPMs are in RPMS/$TARGET_ARCH
1796         # as that's where LTS expects to find them
1797         for dir in RPMS/*; do
1798             if [ $dir = RPMS/$TARGET_ARCH ]; then
1799                 continue
1800             fi
1801             pushd $dir
1802             local files=$(ls)
1803             if [ -n "$files" ]; then
1804                 cp -al $files ../$TARGET_ARCH
1805             fi
1806             popd
1807         done
1808     else
1809         return 1
1810     fi
1811
1812 }
1813
1814 create_rpmbuild_dirs() {
1815
1816         [ -d RPMS ] || mkdir RPMS
1817         [ -d RPMS/${TARGET_ARCH} ] || mkdir RPMS/${TARGET_ARCH}
1818         [ -d RPMS/noarch ] || mkdir RPMS/noarch
1819         [ -d BUILD ] || mkdir BUILD
1820         [ -d SOURCES ] || mkdir SOURCES
1821         [ -d SPECS ] || mkdir SPECS
1822         [ -d SRPMS ] || mkdir SRPMS
1823
1824 }
1825
1826 new_list() {
1827
1828     echo ""
1829
1830 }
1831
1832 add_list() {
1833     local list="$1"
1834     local item="$2"
1835
1836     echo "$list $item"
1837
1838 }
1839
1840 is_list_member() {
1841     local list="$1"
1842     local item="$2"
1843
1844     [[ $list\  == *\ $item\ * ]]
1845
1846 }
1847
1848 #########################################################################
1849 # Generate a backtrace through the call stack.
1850 #
1851 # Input: None
1852 # Output: None
1853 #########################################################################
1854 backtrace() {
1855     local strip=${1:-1}
1856
1857     local funcname="" sourcefile="" lineno="" n
1858
1859     echo "Call stack: (most recent first)"
1860     for (( n = $strip ; n < ${#FUNCNAME[@]} ; ++n )) ; do
1861         funcname=${FUNCNAME[$n - 1]}
1862         sourcefile=$(basename ${BASH_SOURCE[$n]})
1863         lineno=${BASH_LINENO[$n - 1]}
1864         if [ $n = 1 ]; then
1865             let lineno-=11
1866         fi
1867         # Display function arguments
1868         if [[ ! -z "${BASH_ARGV[@]}" ]]; then
1869             local args newarg j p=0
1870             for (( j = ${BASH_ARGC[$n - 1]}; j > 0; j-- )); do
1871                 newarg=${BASH_ARGV[$j + $p - 1]}
1872                 args="${args:+${args} }'${newarg}'"
1873             done
1874             let p+=${BASH_ARGC[$n - 1]}
1875         fi
1876         echo "  ${funcname} ${args:+${args} }at ${sourcefile}:${lineno}"
1877     done
1878
1879     echo
1880     echo "BEGIN BACKTRACE"
1881
1882     #echo ${BASH_LINENO[*]}
1883     #echo ${BASH_SOURCE[*]}
1884     #echo ${FUNCNAME[*]}
1885     local i=$((${#FUNCNAME[@]} - 1))
1886     while [ $i -ge 0 ]; do
1887         local lineno=${BASH_LINENO[$i]}
1888         if [ $i = 0 ]; then
1889             let lineno-=11
1890         fi
1891         local SOURCELINE="${BASH_SOURCE[$i + 1]}:${lineno}"
1892         # Can't figure out how to get function args from other frames...
1893         local FUNCTION="${FUNCNAME[$i]}()"
1894         echo "$SOURCELINE:$FUNCTION"
1895         i=$((i - 1))
1896     done
1897
1898     echo "END BACKTRACE"
1899
1900     echo $BACKTRACE
1901
1902 }
1903
1904 seen_list=$(new_list)
1905 trap 'set +x;
1906 echo "An unexpected error has occurred at ${BASH_SOURCE[0]##*/}:$((LINENO-1)).
1907 Unfortunately the above line number in the message may or may not be correct,
1908 but details have been send to the lbuild maintainer.  Attempting to continue."; (echo "Untrapped error"
1909 echo
1910 # have we seen this one
1911 echo "checking seen list for ${BASH_SOURCE[0]}:${BASH_LINENO[0]}"
1912
1913 if is_list_member "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}"; then
1914   echo "seen this one already"
1915 else
1916   seen_list=$(add_list "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}")
1917 fi
1918 backtrace
1919 ) ; set $xtrace' ERR
1920 set -E
1921
1922 [ -r ~/.lbuildrc ] && . ~/.lbuildrc
1923
1924 options=$(getopt -o D:h -l kerneltree:,distro:,kernelrpm:,reusebuild:,\
1925 patchless,patchless-server,ccache,norpm,external-patches:,timestamp:,\
1926 extraversion:,kerneldir:,linux:,lustre:,nodownload,nosrc,noiokit,ofed-type:,\
1927 ofed-version:,mlnx-version:,ofed-src:,publish,disable-zfs,release,set-value:,\
1928 src,stage:,target:,with-linux:,xen -- "$@")
1929
1930 if [ $? != 0 ]; then
1931     usage 1
1932 fi
1933
1934 eval set -- "$options"
1935
1936 while [ "$1" ]; do
1937     case "$1" in
1938         '')
1939             usage 1
1940             ;;
1941         --ccache)
1942             CCACHE='ccache'
1943             shift
1944             ;;
1945         -D)
1946             DATE=$2
1947             shift 2
1948             ;;
1949         --external-patches)
1950             EXTERNAL_PATCHES=$2
1951             shift 2
1952             ;;
1953         --extraversion)
1954             EXTRA_VERSION=$2
1955             shift 2
1956             ;;
1957         --help | -h)
1958             usage 0
1959             ;;
1960         --kerneldir)
1961             KERNELDIR=$2
1962             shift 2
1963             ;;
1964         --kerneltree)
1965             if ! KERNELTREE=$(canon_path "$2"); then
1966                 fatal 1 "Could not determine the canonical location of $2"
1967             fi
1968             shift 2
1969             ;;
1970         --linux | --with-linux)
1971             if ! LINUX=$(canon_path "$2"); then
1972                 fatal 1 "Could not determine the canonical location of $2"
1973             fi
1974             shift 2
1975             ;;
1976         --distro)
1977             DISTRO=$2
1978             shift 2
1979             ;;
1980         --reusebuild)
1981             if ! REUSEBUILD=$(canon_path "$2"); then
1982                 fatal 1 "Could not determine the canonical location of $2"
1983             fi
1984             shift 2
1985             ;;
1986         --norpm)
1987             shift
1988             ;;
1989         --noiokit)
1990             IOKITRPM=false
1991             shift
1992             ;;
1993         --patchless)
1994             PATCHLESS=true
1995             shift
1996             ;;
1997         --patchless-server)
1998                 PATCHLESS_SERVER=true
1999                 shift
2000                 ;;
2001         --kernelrpm)
2002             if ! KERNELRPMSBASE=$(canon_path "$2"); then
2003                 fatal 1 "Could not determine the canonical location of $2"
2004             fi
2005             shift 2
2006             ;;
2007         --timestamp)
2008             TIMESTAMP=$2
2009             shift 2
2010             ;;
2011         --lustre)
2012             if ! LUSTRE=$(canon_filepath "$2"); then
2013                 fatal 1 "Could not determine the canonical location of $2"
2014             fi
2015             shift 2
2016             ;;
2017         --nodownload)
2018             DOWNLOAD=false
2019             shift 1
2020             ;;
2021         --nosrc)
2022             DO_SRC=false
2023             shift 1
2024             ;;
2025         --ofed-version)
2026             OFED_VERSION="$2"
2027             shift 2
2028             ;;
2029         --ofed-type)
2030                 OFED_TYPE="$2"
2031                 shift 2
2032                 ;;
2033         --ofed-src)
2034                 OFED_SRC="$2"
2035                 shift 2
2036                 ;;
2037         --publish)
2038             shift
2039             ;;
2040         --disable-zfs)
2041             WITH_ZFS="no"
2042             shift
2043             ;;
2044         --release)
2045             RELEASE=true
2046             shift
2047             ;;
2048         --src)
2049             DO_SRC=true
2050             shift 1
2051             ;;
2052         --stage)
2053             STAGEDIR=$2
2054             shift 2
2055             ;;
2056         --target)
2057             TARGET=$2
2058             shift 2
2059             ;;
2060         --xen)
2061             XEN=true
2062             shift
2063             ;;
2064         --set-value)
2065             eval $2
2066             shift 2
2067             ;;
2068         --)
2069             shift
2070             # there are actually some lustre configure flags that we need to
2071             # handle ourselves (but we still give them to configure)
2072             if [[ \ $@\  == *\ --disable-tests\ * ]]; then
2073                 LUSTRE_TESTS=false
2074             fi
2075             CONFIGURE_FLAGS=$@
2076             break
2077             ;;
2078         *)
2079             usage 1 "Unrecognized option: $1"
2080             ;;
2081     esac
2082 done
2083
2084 check_options
2085
2086 unpack_lustre
2087
2088 load_target
2089
2090         if [ -n "$OFED_TYPE" -a "$OFED_TYPE" != "inkernel" ]; then
2091                 download_ofed "$OFED_TYPE" "$OFED_VERSION"
2092                 unpack_ofed "$OFED_TYPE" "$OFED_VERSION" || fatal 1 "Error unpacking OFED tarball"
2093         fi
2094
2095 # make sure the RPM build environment is set up
2096 create_rpmbuild_dirs
2097
2098 # if an unpacked kernel source tree was given on the command line
2099 # just build lustre with it (nothing distro kernel specific here)
2100 if [ -n "$LINUX" ]; then
2101     find_linux_release() {
2102         _find_linux_release $LINUX
2103     }
2104         build_ofed "${LINUXOBJ:-$LINUX}" "$OFED_TYPE" "$OFED_VERSION" ||
2105         fatal 1 "error building OFED"
2106     build_lustre "$LINUX" "$LINUXOBJ"
2107 else
2108     if [ ! -f "${LBUILD_DIR}/lbuild-$DISTROMAJ" ]; then
2109         fatal 1 "${LBUILD_DIR}/lbuild-$DISTROMAJ not found"
2110     fi
2111     source ${LBUILD_DIR}/lbuild-$DISTROMAJ
2112         build_with_srpm "$OFED_TYPE" "$OFED_VERSION" || fatal 1 "Failed to build_with_srpm"
2113 fi
2114
2115 stage